module dwt.internal.win32.func;

private import dwt.internal.win32.types;

extern (Windows)
{
    int AbortDoc (int hdc);
    int ActivateKeyboardLayout(int hkl, int Flags);
    BOOL AdjustWindowRectEx (RECT* lpRect, int dwStyle, BOOL bMenu, int dwExStyle);
    BOOL Arc (int hdc,int nLeftRect,int nTopRect,int nRightRect,int nBottomRect,int nXStartArc,int nYStartArc,int nXEndArc,int nYEndArc);
    int BeginDeferWindowPos (int nNumWindows);
    int BeginPaint (int hWnd, PAINTSTRUCT* lpPaint);
    BOOL BitBlt (int hdcDest,int nXDest,int nYDest,int nWidth,int nHeight,int hdcSrc,int nXSrc,int nYSrc,int dwRop);
    BOOL BringWindowToTop (int hWnd);
    int Call (int address, DLLVERSIONINFO* arg0);
    int CallNextHookEx(int hhk, int nCode, int wParam, int lParam);
    int CallWindowProcW (int lpPrevWndFunc, int hWnd, int Msg, int wParam, int lParam);
    int CallWindowProcA (int lpPrevWndFunc, int hWnd, int Msg, int wParam, int lParam);
    short CharLowerW (short ch);
    short CharLowerA (short ch);
    short CharUpperW (short ch);
    short CharUpperA (short ch);
    BOOL CheckMenuItem (int hmenu, int uIDCheckItem, int uCheck);
    //BOOL ChooseColorW (CHOOSECOLOR* lpcc);
    //BOOL ChooseColorA (CHOOSECOLOR* lpcc);
    //BOOL ChooseFontW (CHOOSEFONT chooseFont);
    //BOOL ChooseFontA (CHOOSEFONT chooseFont);
    BOOL ClientToScreen (int hWnd, POINT* lpPoint);
    BOOL CloseClipboard ();
    int CombineRgn (int hrgnDest, int hrgnSrc1, int hrgnSrc2, int fnCombineMode);
    BOOL CommandBar_AddAdornments (int hwndCB, int dwFlags, int dwReserved);
    int CommandBar_Create (int hInst, int hwndParent, int idCmdBar);
    void CommandBar_Destroy (int hwndCB);
    BOOL CommandBar_DrawMenuBar (int hwndCB, int iButton);
    int CommandBar_Height (int hdnwCB);
    BOOL CommandBar_InsertMenubarEx (int hwndCB, int hInst, int pszMenu, int iButton);
    BOOL CommandBar_Show (int hwndCB, BOOL fShow);
    int CommDlgExtendedError ();
    int CopyImage (int hImage, int uType, int cxDesired, int cyDesired, int fuFlags);
    int CreateAcceleratorTableW (wchar* lpaccl, int cEntries);
    int CreateAcceleratorTableA (char* lpaccl, int cEntries);
    int CreateBitmap (int nWidth, int nHeight, int cPlanes, int cBitsPerPel, byte* lpvBits);
    BOOL CreateCaret (int hWnd, int hBitmap, int nWidth, int nHeight);
    int CreateCompatibleBitmap (int hdc, int nWidth, int nHeight);

    int CreateCompatibleDC (int hdc);
    int CreateCursor (int hInst, int xHotSpot, int yHotSpot, int nWidth, int nHeight, byte[]* pvANDPlane, byte[]* pvXORPlane);
    int CreateDCW (wchar* lpszDriver, wchar* lpszDevice, int lpszOutput, int lpInitData);
    int CreateDCA (char* lpszDriver, char* lpszDevice, int lpszOutput, int lpInitData);
    int CreateDIBSection(int hdc, BITMAPINFOHEADER* pbmi, int iUsage, byte** ppvBits, int hSection, int dwOffset);
    int CreateFontIndirectW (LOGFONTW* lplf);
    int CreateFontIndirectA (LOGFONTA* lplf);
    int CreateIconIndirect (ICONINFO* lplf);
    int CreateMenu ();
    int CreatePalette (byte[] logPalette);
    int CreatePatternBrush (int colorRef);
    int CreatePen (int fnPenStyle, int nWidth, int crColor);
    int CreatePolygonRgn(int[] lppt, int cPoints, int fnPolyFillMode);
    int CreatePopupMenu ();
    int CreateRectRgn (int left, int top, int right, int bottom);
    int CreateSolidBrush (int colorRef);
    int CreateStreamOnHGlobal(int hGlobal, BOOL fDeleteOnRelease, int[] ppstm);
    int CreateWindowExW (int dwExStyle, wchar* lpClassName, wchar* lpWindowName, int dwStyle, int X, int Y, int nWidth, int nHeight, int hWndParent, int hMenu, int hInstance, CREATESTRUCT* lpParam);
    int CreateWindowExA (int dwExStyle, char* lpClassName, char* lpWindowName, int dwStyle, int X, int Y, int nWidth, int nHeight, int hWndParent, int hMenu, int hInstance, CREATESTRUCT* lpParam);
    int DeferWindowPos (int hWinPosInfo, int hWnd, int hWndInsertAfter, int X, int Y, int cx, int cy, int uFlags);
    int DefMDIChildProcW (int hWnd, int Msg, int wParam, int lParam);
    int DefMDIChildProcA (int hWnd, int Msg, int wParam, int lParam);
    int DefFrameProcW (int hWnd, int hWndMDIClient, int Msg, int wParam, int lParam);
    int DefFrameProcA (int hWnd, int hWndMDIClient, int Msg, int wParam, int lParam);
    int DefWindowProcW (int hWnd, int Msg, int wParam, int lParam);
    int DefWindowProcA (int hWnd, int Msg, int wParam, int lParam);
    BOOL DeleteDC (int hdc);
    BOOL DeleteMenu (int hMenu, int uPosition, int uFlags);
    BOOL DeleteObject (int hGdiObj);
    BOOL DestroyAcceleratorTable (int hAccel);
    BOOL DestroyCaret ();
    BOOL DestroyCursor (int hCursor);
    BOOL DestroyIcon (int hIcon);
    BOOL DestroyMenu (int hMenu);
    BOOL DestroyWindow (int hWnd);
    int DispatchMessageW (MSG* lpmsg);
    int DispatchMessageA (MSG* lpmsg);
    BOOL DragDetect (int hwnd, POINT pt);
    void DragFinish (int hDrop);
    int DragQueryFileA (int hDrop, int iFile, char* lpszFile, int cch);
    int DragQueryFileW (int hDrop, int iFile, wchar* lpszFile, int cch);
    BOOL DrawEdge (int hdc, RECT* qrc, int edge, int grfFlags);
    BOOL DrawFocusRect (int hDC, RECT* lpRect);
    BOOL DrawFrameControl (int hdc, RECT* lprc, int uType, int uState);
    BOOL DrawIconEx (int hdc, int xLeft, int yTop, int hIcon, int cxWidth, int cyWidth, int istepIfAniCur, int hbrFlickerFreeDraw, int diFlags);
    BOOL DrawMenuBar (int hWnd);
    BOOL DrawStateW (int hdc, int hbr, int lpOutputFunc, int lData, int wData, int x, int y, int cx, int cy, int fuFlags);
    BOOL DrawStateA (int hdc, int hbr, int lpOutputFunc, int lData, int wData, int x, int y, int cx, int cy, int fuFlags);
    int DrawTextW (int hDC, wchar* lpString, int nCount, RECT* lpRect, int uFormat);
    int DrawTextA (int hDC, char* lpString, int nCount, RECT* lpRect, int uFormat);
    BOOL Ellipse (int hdc,int nLeftRect,int nTopRect,int nRightRect,int nBottomRect);
    BOOL EnableMenuItem (int hMenu, int uIDEnableItem, int uEnable);
    BOOL EnableScrollBar (int hWnd, int wSBflags, int wArrows);
    BOOL EnableWindow (int hWnd, BOOL bEnable);
    BOOL EnumSystemLanguageGroupsW(int pLangGroupEnumProc, int dwFlags, int lParam);
    BOOL EnumSystemLanguageGroupsA(int pLangGroupEnumProc, int dwFlags, int lParam);
    BOOL EnumSystemLocalesW(void* lpLocaleEnumProc, int dwFlags);
    BOOL EnumSystemLocalesA(void* lpLocaleEnumProc, int dwFlags);
    BOOL EndDeferWindowPos (int hWinPosInfo);
    int EndDoc (int hdc);
    int EndPage (int hdc);
    int EndPaint (int hWnd, PAINTSTRUCT* lpPaint);
    BOOL EnumDisplayMonitors (int hdc, RECT* lprcClip, int lpfnEnum, int dwData);
    int EnumFontFamiliesW (int hdc, wchar* lpszFamily, int lpEnumFontFamProc, int lParam);
    int EnumFontFamiliesA (int hdc, char* lpszFamily, int lpEnumFontFamProc, int lParam);
    BOOL EqualRect (RECT* lprc1, RECT* lprc2);
    BOOL EqualRgn (int hSrcRgn1, int hSrcRgn2);
    int ExpandEnvironmentStringsW (wchar* lpSrc, wchar* lsDst, int nSize);
    int ExpandEnvironmentStringsA (char* lpSrc, char* lsDst, int nSize);
    BOOL ExtTextOutW(int hdc, int X, int Y, int fuOptions, RECT* lprc, wchar* lpString, int cbCount, int[] lpDx);
    BOOL ExtTextOutA(int hdc, int X, int Y, int fuOptions, RECT* lprc, char* lpString, int cbCount, int[] lpDx);
    int ExtractIconExW (wchar* lpszFile, int nIconIndex, int [] phiconLarge, int [] phiconSmall, int nIcons);
    int ExtractIconExA (char* lpszFile, int nIconIndex, int [] phiconLarge, int [] phiconSmall, int nIcons);
    int FillRect(int hDC, RECT* lprc, int hbr);
    int FindWindowA (char* lpClassName, char* lpWindowName);
    int FindWindowW (wchar* lpClassName, wchar* lpWindowName);
    BOOL FreeLibrary (int hLibModule);
    int GetACP ();
    int GetActiveWindow ();
    int GetBkColor (int hDC);
    int GetCapture ();
    BOOL GetCaretPos (POINT* lpPoint);
    BOOL GetCharABCWidthsA (int hdc, int iFirstChar, int iLastChar, int [] lpabc);
    BOOL GetCharABCWidthsW (int hdc, int iFirstChar, int iLastChar, int [] lpabc);
    int GetCharacterPlacementW(int hdc, wchar* lpString, int nCount, int nMaxExtent, GCP_RESULTS* lpResults, int dwFlags);
    int GetCharacterPlacementA(int hdc, char* lpString, int nCount, int nMaxExtent, GCP_RESULTS* lpResults, int dwFlags);
    BOOL GetCharWidthA (int hdc, int iFirstChar, int iLastChar, int [] lpBuffer);
    BOOL GetCharWidthW (int hdc, int iFirstChar, int iLastChar, int [] lpBuffer);
    BOOL GetClassInfoW (int hInstance, wchar* lpClassName, WNDCLASS* lpWndClass);
    BOOL GetClassInfoA (int hInstance, char* lpClassName, WNDCLASS* lpWndClass);
    BOOL GetClientRect (int hWnd, RECT* lpRect);
    int GetClipboardData (int uFormat);
    int GetClipboardFormatNameA (int format, char* lpszFormatName, int cchMaxCount);
    int GetClipboardFormatNameW (int format, wchar* lpszFormatName, int cchMaxCount);
    int GetClipBox (int hdc, RECT* lprc);
    int GetClipRgn (int hdc, int hrgn);
    //BOOL GetComboBoxInfo (int hwndCombo, COMBOBOXINFO* pcbi);
    int GetCurrentObject (int hdc, int uObjectType);
    int GetCurrentProcessId ();
    int GetCurrentThreadId ();
    int GetCursor ();
    BOOL GetCursorPos (POINT* lpPoint);
    int GetDC (int hwnd);
    int GetDCEx (int hWnd, int hrgnClip, int flags);
    int GetDesktopWindow ();
    int GetDeviceCaps (int hdc, int nIndex);
    int GetDialogBaseUnits ();
    int GetDIBColorTable (int hdc, int uStartIndex, int cEntries, byte* pColors);
    int GetDIBits (int hdc, int hbmp, int uStartScan, int cScanLines, byte* lpvBits, BITMAPINFOHEADER* lpbi, int uUsage);
    int GetDlgItem (int hDlg, int nIDDlgItem);
    int GetDoubleClickTime ();
    int GetFocus ();
    int GetFontLanguageInfo(int hdc);
    BOOL GetIconInfo (int hIcon, ICONINFO* piconinfo);
    int GetKeyboardLayoutList(int nBuff, int[] lpList);
    int GetKeyboardLayout(int idThread);short GetKeyState (int nVirtKey);
    BOOL GetKeyboardState (char* lpKeyState);
    int GetKeyNameTextW(int lParam, wchar* lpString, int nSize);
    int GetKeyNameTextA(int lParam, char* lpString, int nSize);
    int GetLastActivePopup (int hWnd);
    int GetLastError ();
    int GetLayout (int hdc);
    /* returns the instance handle to the swt library */
    int GetLibraryHandle ();
    int GetLocaleInfoW (int Locale, int LCType, wchar* lpLCData, int cchData);
    int GetLocaleInfoA (int Locale, int LCType, char* lpLCData, int cchData);
    int GetMenu (int hWnd);
    int GetMenuDefaultItem (int hMenu, int fByPos, int gmdiFlags);
    BOOL GetMenuInfo (int hmenu, MENUINFO* lpcmi);
    int GetMenuItemCount (int hMenu);
    BOOL GetMenuItemInfoW (int hMenu, int uItem, BOOL fByPosition, MENUITEMINFO* lpmii);
    BOOL GetMenuItemInfoA (int hMenu, int uItem, BOOL fByPosition, MENUITEMINFO* lpmii);
    BOOL GetMessageW (MSG lpMsg, int hWnd, int wMsgFilterMin, int wMsgFilterMax);
    BOOL GetMessageA (MSG lpMsg, int hWnd, int wMsgFilterMin, int wMsgFilterMax);
    int GetMessagePos ();
    int GetMessageTime ();
    int GetTextCharset(int hdc);
    int GetTickCount ();
    int GetModuleHandleW (wchar* lpModuleName);
    int GetModuleHandleA (char* lpModuleName);
    BOOL GetMonitorInfoW (int hmonitor, MONITORINFO* lpmi);
    BOOL GetMonitorInfoA (int hmonitor, MONITORINFO* lpmi);
    int GetNearestPaletteIndex(int hPal, int crColor);

    int GetObjectA (int hgdiobj, int cbBuffer, void* lpvObject);
    int GetObjectW (int hgdiobj, int cbBuffer, void* lpvObject);
    int GetObjectA (int hgdiobj, int cbBuffer, BITMAP* lpvObject);
    int GetObjectW (int hgdiobj, int cbBuffer, BITMAP* lpvObject);
    int GetObjectA (int hgdiobj, int cbBuffer, DIBSECTION* lpvObject);
    int GetObjectW (int hgdiobj, int cbBuffer, DIBSECTION* lpvObject);
    int GetObjectA (int hgdiobj, int cbBuffer, LOGBRUSH* lpvObject);
    int GetObjectW (int hgdiobj, int cbBuffer, LOGBRUSH* lpvObject);
    int GetObjectA (int hgdiobj, int cbBuffer, LOGFONTA* lpvObject);
    int GetObjectW (int hgdiobj, int cbBuffer, LOGFONTW* lpvObject);
    int GetObjectA (int hgdiobj, int cbBuffer, LOGPEN* lpvObject);
    int GetObjectW (int hgdiobj, int cbBuffer, LOGPEN* lpvObject);
    BOOL GetOpenFileNameW (OPENFILENAME* lpofn);
    BOOL GetOpenFileNameA (OPENFILENAME* lpofn);
    int GetPaletteEntries (int hPalette, int iStartIndex, int nEntries, byte[] logPalette);
    int GetParent (int hWnd);
    int GetPixel (int hdc, int x, int y);
    int GetProcAddress (int hModule, char[]* lpProcName);
    int GetProcessHeap ();
    int GetProfileStringW (wchar* lpAppName, wchar* lpKeyName, wchar* lpDefault, wchar* lpReturnedString, int nSize);
    int GetProfileStringA (char* lpAppName, char* lpKeyName, char* lpDefault, char* lpReturnedString, int nSize);
    int GetRegionData (int hRgn, int dwCount, int [] lpRgnData);
    int GetRgnBox (int hrgn, RECT* lprc);
    int GetROP2 (int hdc);
    BOOL GetSaveFileNameW (OPENFILENAME* lpofn);
    BOOL GetSaveFileNameA (OPENFILENAME* lpofn);
    BOOL GetScrollInfo (int hwnd, int flags, SCROLLINFO* info);
    int GetStockObject (int fnObject);
    int GetSysColor (int nIndex);
    int GetSysColorBrush (int nIndex);
    int GetSystemMenu (int hWnd, BOOL bRevert);
    int GetSystemMetrics (int nIndex);
    int GetSystemPaletteEntries(int hdc, int iStartIndex, int nEntries, byte[] lppe);
    int GetTextColor (int hDC);
    BOOL GetTextExtentPoint32W (int hdc, wchar* lpString, int cbString, SIZE* lpSize);
    BOOL GetTextExtentPoint32A (int hdc, char* lpString, int cbString, SIZE* lpSize);
    BOOL GetTextMetricsW (int hdc, TEXTMETRICW* lptm);
    BOOL GetTextMetricsA (int hdc, TEXTMETRICA* lptm);
    BOOL GetUpdateRect (int hWnd, RECT* lpRect, BOOL bErase);
    int GetUpdateRgn (int hWnd, int hRgn, BOOL bErase);
    BOOL GetVersionExW (OSVERSIONINFOW* lpVersionInfo);
    BOOL GetVersionExA (OSVERSIONINFOA* lpVersionInfo);
    int GetWindow (int hWnd, int uCmd);
    int GetWindowLongW (int hWnd, int nIndex);
    int GetWindowLongA (int hWnd, int nIndex);
    BOOL GetWindowPlacement (int hWnd, WINDOWPLACEMENT* lpwndpl);
    BOOL GetWindowRect (int hWnd, RECT* lpRect);
    int GetWindowRgn(int hWnd, int hRgn);
    int GetWindowTextW (int hWnd, wchar* lpString, int nMaxCount);
    int GetWindowTextA (int hWnd, char* lpString, int nMaxCount);
    int GetWindowTextLengthW (int hWnd);
    int GetWindowTextLengthA (int hWnd);
    int GetWindowThreadProcessId (int hWnd, int [] lpdwProcessId);
    int GlobalAlloc (int uFlags, int dwBytes);
    int GlobalFree (int hMem);
    int GlobalLock (int hMem);
    int GlobalSize (int hMem);
    BOOL GlobalUnlock (int hMem);
    BOOL GradientFill(int hdc, TRIVERTEX* pVertex, int dwNumVertex, void* pMesh, int dwNumMesh, int dwMode);
    int HeapAlloc (int hHeap, int dwFlags, int dwBytes);
    BOOL HeapFree (int hHeap, int dwFlags, int lpMem);
    BOOL HideCaret (int hWnd);
    int ImageList_Add (int himl, int hbmImage, int hbmMask);
    int ImageList_AddMasked (int himl, int hbmImage, int crMask);
    int ImageList_Create (int cx, int cy, int flags, int cInitial, int cGrow);
    BOOL ImageList_Destroy (int himl);
    int ImageList_GetIcon (int himl, int i, int flags);
    BOOL ImageList_GetIconSize (int himl, int [] cx, int [] cy);
    int ImageList_GetImageCount (int himl);
    BOOL ImageList_Remove (int himl, int i);
    BOOL ImageList_Replace (int himl, int i, int hbmImage, int hbmMask);
    int ImageList_ReplaceIcon (int himl, int i, int hicon);
    BOOL ImageList_SetIconSize (int himl, int cx, int cy);
    int ImmAssociateContext (int hWnd, int hIMC);
    int ImmCreateContext ();
    BOOL ImmDestroyContext (int hIMC);
    BOOL ImmGetCompositionFontW (int hIMC, LOGFONTW* lplf);
    BOOL ImmGetCompositionFontA (int hIMC, LOGFONTA* lplf);
    int ImmGetCompositionStringW (int hIMC, int dwIndex, wchar* lpBuf, int dwBufLen);
    int ImmGetCompositionStringA (int hIMC, int dwIndex, char* lpBuf, int dwBufLen);
    int ImmGetContext (int hWnd);
    BOOL ImmGetConversionStatus (int hIMC, int [] lpfdwConversion, int [] lpfdwSentence);
    int ImmGetDefaultIMEWnd (int hWnd);
    BOOL ImmGetOpenStatus (int hIMC);
    BOOL ImmReleaseContext (int hWnd, int hIMC);
    BOOL ImmSetCompositionFontW (int hIMC, LOGFONTW* lplf);
    BOOL ImmSetCompositionFontA (int hIMC, LOGFONTA* lplf);
    BOOL ImmSetCompositionWindow (int hIMC, COMPOSITIONFORM lpCompForm);
    BOOL ImmSetConversionStatus (int hIMC, int fdwConversion, int dwSentence);
    BOOL ImmSetOpenStatus (int hIMC, BOOL fOpen);
    void InitCommonControls ();
    BOOL InitCommonControlsEx (INITCOMMONCONTROLSEX lpInitCtrls);
    BOOL InsertMenuW (int hMenu, int uPosition, int uFlags, int uIDNewItem, wchar* lpNewItem);
    BOOL InsertMenuA (int hMenu, int uPosition, int uFlags, int uIDNewItem, char* lpNewItem);
    BOOL InsertMenuItemW (int hMenu, int uItem, BOOL fByPosition, MENUITEMINFO* lpmii);
    BOOL InsertMenuItemA (int hMenu, int uItem, BOOL fByPosition, MENUITEMINFO* lpmii);
    BOOL InvalidateRect(int hWnd, RECT* lpRect, BOOL bErase);
    BOOL InvalidateRgn (int hWnd, int hRgn, BOOL bErase);
    BOOL IsDBCSLeadByte (byte TestChar);
    BOOL IsIconic (int hWnd);
    //static int IsPPC();
    //static int IsSP();
    BOOL IsWindowEnabled (int hWnd);
    BOOL IsWindowVisible (int hWnd);
    BOOL IsZoomed (int hWnd);
    BOOL KillTimer (int hWnd, int uIDEvent);
    BOOL LineTo (int hdc,int x1, int x2);
    int LoadBitmapW (int hInstance, int lpBitmapName);
    int LoadBitmapA (int hInstance, int lpBitmapName);
    int LoadCursorW (int hInstance, int lpCursorName);
    int LoadCursorA (int hInstance, int lpCursorName);
    int LoadIconW (int hInstance, int lpIconName);
    int LoadIconA (int hInstance, int lpIconName);
    int LoadImageW (int hinst, wchar* lpszName, int uType, int cxDesired, int cyDesired, int fuLoad);
    int LoadImageA (int hinst, char* lpszName, int uType, int cxDesired, int cyDesired, int fuLoad);
    int LoadLibraryW (wchar* lpLibFileName);
    int LoadLibraryA (char* lpLibFileName);
    int MapVirtualKeyW (int uCode, int uMapType);
    int MapVirtualKeyA (int uCode, int uMapType);
    int MapWindowPoints (int hWndFrom, int hWndTo, POINT* lpPoints, int cPoints);
    int MapWindowPoints (int hWndFrom, int hWndTo, RECT* lpPoints, int cPoints);
    BOOL MessageBeep (int uType);
    int MessageBoxW (int hWnd, wchar* lpText, wchar* lpCaption, int uType);
    int MessageBoxA (int hWnd, char* lpText, char* lpCaption, int uType);
    int MonitorFromWindow (int hwnd, int dwFlags);

	/+ 2004.5.23 BSA
	 +	rem'd out the general MoveMemory and uncommented the others
	 +	(Andy's work, maybe?)
	 +/

    // :P
    //void MoveMemory(void* destination, void* source, int length);

    void MoveMemory (char[] Destination, int SourcePtr, int Length);
    void MoveMemory (char* Destination, int Source, int Length);
    void MoveMemory (char* Destination, ACCEL Source, int Length);
    void MoveMemory (char* Destination, BITMAPINFOHEADER Source, int Length);
    void MoveMemory (int [] Destination, int Source, int Length);
    void MoveMemory (int Destination, byte[] Source, int Length);
//    void MoveMemory (int Destination, char* Source, int Length);
    void MoveMemory (int Destination, wchar* Source, int Length);
    void MoveMemory (int Destination, int [] Source, int Length);
    void MoveMemory (int Destination, GRADIENT_RECT Source, int Length);
    void MoveMemory (int Destination, LOGFONTW Source, int Length);
    void MoveMemory (int Destination, LOGFONTA Source, int Length);
    void MoveMemory (int Destination, MEASUREITEMSTRUCT Source, int Length);
    void MoveMemory (int Destination, MSG Source, int Length);
    void MoveMemory (int Destination, NMTTDISPINFOW Source, int Length);
    void MoveMemory (int Destination, NMTTDISPINFOA Source, int Length);
    void MoveMemory (int Destination, RECT* Source, int Length);
    void MoveMemory (int Destination, TRIVERTEX Source, int Length);
    void MoveMemory (int Destination, WINDOWPOS* Source, int Length);
    void MoveMemory (BITMAPINFOHEADER* Destination, char* Source, int Length);
    void MoveMemory (DRAWITEMSTRUCT Destination, int Source, int Length);
    //void MoveMemory (HDITEM Destination, int Source, int Length);
    void MoveMemory (HELPINFO* Destination, int Source, int Length);
    void MoveMemory (LOGFONTW Destination, int Source, int Length);
    void MoveMemory (LOGFONTA Destination, int Source, int Length);
    void MoveMemory (MEASUREITEMSTRUCT Destination, int Source, int Length);
    void MoveMemory (NMHDR* Destination, int Source, int Length);
//    void MoveMemory (NMRGINFO* Destination, int Source, int Length);
//    void MoveMemory (NMCUSTOMDRAW* Destination, int Source, int Length);
//    void MoveMemory (NMLVCUSTOMDRAW* Destination, int Source, int Length);
//    void MoveMemory (NMTVCUSTOMDRAW* Destination, int Source, int Length);
//    void MoveMemory (int Destination, NMLVCUSTOMDRAW* Source, int Length);
//    void MoveMemory (int Destination, NMTVCUSTOMDRAW* Source, int Length);
//    void MoveMemory (int Destination, NMLVDISPINFO* Source, int Length);
//    void MoveMemory (NMLVDISPINFO* Destination, int Source, int Length);
//    void MoveMemory (NMHEADER* Destination, int Source, int Length);
//    void MoveMemory (NMLISTVIEW* Destination, int Source, int Length);
//    void MoveMemory (NMREBARCHEVRON Destination, int Source, int Length);
    //void MoveMemory (NMTOOLBAR Destination, int Source, int Length);
    void MoveMemory (NMTTDISPINFOW Destination, int Source, int Length);
    void MoveMemory (NMTTDISPINFOA Destination, int Source, int Length);
    void MoveMemory (TVITEM Destination, int Source, int Length);
    void MoveMemory (WINDOWPOS* Destination, int Source, int Length);
    void MoveMemory (MSG Destination, int Source, int Length);
    //void MoveMemory(int Destination, DROPFILES Source, int Length);
    void MoveMemory(double[] Destination, int SourcePtr, int Length);
    void MoveMemory(float[] Destination, int SourcePtr, int Length);
    void MoveMemory(short[] Destination, int SourcePtr, int Length);
    void MoveMemory(int DestinationPtr, double[] Source, int Length);
    void MoveMemory(int DestinationPtr, float[] Source, int Length);
    void MoveMemory(int DestinationPtr, short[] Source, int Length);


    BOOL MoveToEx (int hdc,int x1, int x2, int lPoint);
    int MsgWaitForMultipleObjectsEx (int nCount, int pHandles, int dwMilliseconds, int dwWakeMask, int dwFlags);
    int MultiByteToWideChar (int CodePage, int dwFlags, char* lpMultiByteStr, int cchMultiByte, wchar* lpWideCharStr, int cchWideChar);
    int MultiByteToWideChar (int CodePage, int dwFlags, int lpMultiByteStr, int cchMultiByte, wchar* lpWideCharStr, int cchWideChar);
    int OleInitialize (int pvReserved);
    void OleUninitialize ();
    BOOL OpenClipboard (int hWndNewOwner);
    BOOL PatBlt (int hdc,int x1, int x2,int w, int h, int rop);
    BOOL PeekMessageW (MSG* lpMsg, int hWnd, int wMsgFilterMin, int wMsgFilterMax, int wRemoveMsg);
    BOOL PeekMessageA (MSG* lpMsg, int hWnd, int wMsgFilterMin, int wMsgFilterMax, int wRemoveMsg);
    BOOL Pie (int hdc, int nLeftRect, int nTopRect, int nRightRect, int nBottomRect, int nXStartArc, int nYStartArc, int nXEndArc, int nYEndArc);
    BOOL Polygon (int hdc, int [] points, int nPoints);
    BOOL Polyline (int hdc,int[] points, int nPoints);
    BOOL PostMessageW (int hWnd, int Msg, int wParam, int lParam);
    BOOL PostMessageA (int hWnd, int Msg, int wParam, int lParam);
    BOOL PostThreadMessageW (int idThread, int Msg, int wParam, int lParam);
    BOOL PostThreadMessageA (int idThread, int Msg, int wParam, int lParam);
    BOOL PrintDlgW (PRINTDLG lppd);
    BOOL PrintDlgA (PRINTDLG lppd);
    BOOL PtInRect (RECT* rect, POINT* pt);
    BOOL PtInRegion (int hrgn, int X, int Y);
    int RealizePalette(int hDC);
    BOOL Rectangle (int hdc, int nLeftRect, int nTopRect, int nRightRect, int nBottomRect);
    BOOL RectInRegion (int hrgn, RECT* lprc);
    BOOL RedrawWindow (int hWnd, RECT* lprcUpdate, int hrgnUpdate, int flags);
    LONG RegCloseKey (int hKey);
    int RegisterClassW (WNDCLASS* lpWndClass);
    int RegisterClassA (WNDCLASS* lpWndClass);
    int RegEnumKeyExW (int hKey, int dwIndex, wchar* lpName, int [] lpcName, int [] lpReserved, wchar* lpClass, int [] lpcClass, FILETIME* lpftLastWriteTime);
    int RegisterClipboardFormatA (char* lpszFormat);
    int RegisterClipboardFormatW (wchar* lpszFormat);
    int RegOpenKeyExW (int hKey, wchar* lpSubKey, int ulOptions, int samDesired, int[] phkResult);
    int RegQueryInfoKeyW (int hKey, int lpClass, int[] lpcbClass, int lpReserved, int[] lpSubKeys, int[] lpcbMaxSubKeyLen, int[] lpcbMaxClassLen, int[] lpcValues, int[] lpcbMaxValueNameLen, int[] lpcbMaxValueLen, int[] lpcbSecurityDescriptor, int lpftLastWriteTime);
    int RegQueryValueExW (int hKey, wchar* lpValueName, int lpReserved, int[] lpType, wchar* lpData, int[] lpcbData);
    int RegEnumKeyExA (int hKey, int dwIndex, char* lpName, int [] lpcName, int [] lpReserved, char* lpClass, int [] lpcClass, FILETIME* lpftLastWriteTime);
    int RegOpenKeyExA (int hKey, char* lpSubKey, int ulOptions, int samDesired, int[] phkResult);
    int RegQueryInfoKeyA (int hKey, int lpClass, int[] lpcbClass, int lpReserved, int[] lpSubKeys, int[] lpcbMaxSubKeyLen, int[] lpcbMaxClassLen, int[] lpcValues, int[] lpcbMaxValueNameLen, int[] lpcbMaxValueLen, int[] lpcbSecurityDescriptor, int lpftLastWriteTime);
    int RegQueryValueExA (int hKey, char* lpValueName, int lpReserved, int[] lpType, char* lpData, int[] lpcbData);
    BOOL ReleaseCapture ();
    int ReleaseDC (int hWnd, int hDC);
    BOOL RemoveMenu (int hMenu, int uPosition, int uFlags);
    BOOL RoundRect (int hdc, int nLeftRect, int nTopRect, int nRightRect, int nBottomRect, int nWidth, int nHeight);
    BOOL ScreenToClient (int hWnd, POINT* lpPoint);
    int ScrollWindowEx (int hWnd, int dx, int dy, RECT* prcScroll, RECT* prcClip, int hrgnUpdate, RECT* prcUpdate, int flags);
    int SelectClipRgn (int hdc, int hrgn);
    int SelectObject(int hDC, int HGDIObj);
    int SelectPalette(int hDC, int hpal, BOOL bForceBackground);

//    int SendMessageW (int hWnd, int msg, int wparam, int lparam);
//    int SendMessageA (int hWnd, int msg, int wparam, int lparam);

    // D doesn't allow extern(Windows) functions to be overloaded in this manner
//    /*
    int SendMessageW (int hWnd, int Msg, int [] wParam, int [] lParam);
    int SendMessageW (int hWnd, int Msg, int [] wParam, int lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, wchar* lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, int [] lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, short [] lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, int lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, LVCOLUMN* lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, LVHITTESTINFO* lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, LVITEM* lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, REBARBANDINFO* lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, RECT* lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, TBBUTTON* lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, TBBUTTONINFO* lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, TCITEM* lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, TOOLINFO* lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, TVHITTESTINFO* lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, TVINSERTSTRUCT* lParam);
    int SendMessageW (int hWnd, int Msg, int wParam, TVITEM* lParam);
    int SendMessageA (int hWnd, int Msg, int [] wParam, int [] lParam);
    int SendMessageA (int hWnd, int Msg, int [] wParam, int lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, char* lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, int [] lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, short [] lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, int lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, LVCOLUMN* lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, LVHITTESTINFO* lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, LVITEM* lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, REBARBANDINFO* lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, RECT* lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, TBBUTTON* lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, TBBUTTONINFO* lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, TCITEM* lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, TOOLINFO* lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, TVHITTESTINFO* lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, TVINSERTSTRUCT* lParam);
    int SendMessageA (int hWnd, int Msg, int wParam, TVITEM* lParam);
//    */

    int SetActiveWindow (int hWnd);
    int SetBkColor (int hdc, int colorRef);
    int SetBkMode (int hdc, int mode);
    int SetCapture (int hWnd);
    BOOL SetCaretPos (int X, int Y);
    int SetClipboardData (int uFormat, int hMem);
    int SetCursor (int hCursor);
    BOOL SetCursorPos (int X, int Y);
    int SetDIBColorTable (int hdc, int uStartIndex, int cEntries, byte[] pColors);
    int SetErrorMode (int uMode);
    int SetFocus (int hWnd);
    BOOL SetForegroundWindow (int hWnd);
    int SetLayout (int hdc, int dwLayout);
    BOOL SetMenu (int hWnd, int hMenu);
    BOOL SetMenuDefaultItem (int hMenu, int uItem, int fByPos);
    BOOL SetMenuInfo (int hmenu, MENUINFO* lpcmi);
    BOOL SetMenuItemInfoW (int hMenu, int uItem, BOOL fByPosition, MENUITEMINFO* lpmii);
    BOOL SetMenuItemInfoA (int hMenu, int uItem, BOOL fByPosition, MENUITEMINFO* lpmii);
    int SetPaletteEntries (int hPal, int iStart, int cEntries, byte[] lppe);
    int SetParent (int hWndChild, int hWndNewParent);
    int SetPixel (int hdc, int X, int Y, int crColor);
    BOOL SetRect(RECT* lprc, int xLeft, int yTop, int xRight, int yBottom);
    BOOL SetRectRgn (int hrgn, int nLeftRect, int nTopRect, int nRightRect, int nBottomRect);
    int SetROP2 (int hdc, int fnDrawMode);
    BOOL SetScrollInfo (int hwnd, int flags, SCROLLINFO* info, BOOL fRedraw);
    int SetStretchBltMode(int hdc, int iStretchMode);
    int SetTextAlign(int hdc, int fMode);
    int SetTextColor (int hdc, int colorRef);
    int SetTimer (int hWnd, int nIDEvent, int Elapse, int lpTimerFunc);
    int SetWindowLongW (int hWnd, int nIndex, int dwNewLong);
    int SetWindowLongA (int hWnd, int nIndex, int dwNewLong);
    BOOL SetWindowPlacement (int hWnd, WINDOWPLACEMENT* lpwndpl);
    BOOL SetWindowPos(int hWnd, int hWndInsertAfter, int X, int Y, int cx, int cy, int uFlags);
    int SetWindowRgn(int hWnd, int hRgn, BOOL bRedraw);
    BOOL SetWindowTextW (int hWnd, wchar* lpString);
    BOOL SetWindowTextA (int hWnd, char* lpString);
    int SetWindowsHookExW (int idHook, int lpfn,  int hMod,  int dwThreadId);
    int SetWindowsHookExA (int idHook, int lpfn,  int hMod,  int dwThreadId);
    int SHBrowseForFolderW (BROWSEINFO* lpbi);
    int SHBrowseForFolderA (BROWSEINFO* lpbi);
    BOOL SHCreateMenuBar(SHMENUBARINFO* pmb);
    BOOL SHHandleWMSettingChange (int hwnd, int wParam, int lParam, SHACTIVATEINFO* psai);
    int SHRecognizeGesture(SHRGINFO* shrg);
    void SHSendBackToFocusWindow (int uMsg, int wp, int lp);
    BOOL SHSipPreference (int hwnd, int st);
    BOOL ShellExecuteExW (SHELLEXECUTEINFO* lpExecInfo);
    BOOL ShellExecuteExA (SHELLEXECUTEINFO* lpExecInfo);
    int SHGetMalloc (int [] ppMalloc);
    BOOL SHGetPathFromIDListW (int pidl, wchar* pszPath);
    BOOL SHGetPathFromIDListA (int pidl, char* pszPath);
    BOOL SHSetAppKeyWndAssoc(byte bVk, int hwnd);
    BOOL ShowCaret (int hWnd);
    BOOL ShowOwnedPopups (int hWnd, BOOL fShow);
    BOOL ShowScrollBar (int hWnd, int wBar, BOOL bShow);
    BOOL ShowWindow (int hWnd, int nCmdShow);
    BOOL SipGetInfo (SIPINFO* pSipInfo);
    int StartDocW (int hdc, DOCINFO* lpdi);
    int StartDocA (int hdc, DOCINFO* lpdi);
    int StartPage (int hdc);
    BOOL StretchBlt (int hdcDest, int nXOriginDest, int nYOriginDest, int nWidthDest, int nHeightDest, int hdcSrc, int nXOriginSrc, int nYOriginSrc, int nWidthSrc, int nHeightSrc, int dwRop);

    int SystemParametersInfoA(int uiAction, int uiParam, int pvParam, int fWinIni);
    int SystemParametersInfoW(int uiAction, int uiParam, int pvParam, int fWinIni);

    BOOL SystemParametersInfoW (int uiAction, int uiParam, RECT* pvParam, int fWinIni);
    BOOL SystemParametersInfoA (int uiAction, int uiParam, RECT* pvParam, int fWinIni);
    BOOL SystemParametersInfoW (int uiAction, int uiParam, NONCLIENTMETRICSW* pvParam, int fWinIni);
    BOOL SystemParametersInfoA (int uiAction, int uiParam, NONCLIENTMETRICSA* pvParam, int fWinIni);
    BOOL SystemParametersInfoW (int uiAction, int uiParam, int[] pvParam, int fWinIni);
    BOOL SystemParametersInfoA (int uiAction, int uiParam, int[] pvParam, int fWinIni);

    int ToAscii(int uVirtKey, int uScanCode, byte[]* lpKeyState, char[]* lpChar, int uFlags);
    int ToUnicode(int wVirtKey, int wScanCode, byte[]* lpKeyState, wchar* pwszBuff, int cchBuff, int wFlags);
    BOOL TrackMouseEvent(TRACKMOUSEEVENT* lpEventTrack);
    BOOL TrackPopupMenu (int hMenu, int uFlags, int x, int y, int nReserved, int hWnd, RECT* prcRect);
    int TranslateAcceleratorW (int hWnd, int hAccTable, MSG lpMsg);
    int TranslateAcceleratorA (int hWnd, int hAccTable, MSG lpMsg);
    BOOL TranslateCharsetInfo(int lpSrc, int [] lpCs, int dwFlags);
    BOOL TranslateMDISysAccel (int hWndClient, MSG lpMsg);
    BOOL TranslateMessage(MSG* lpmsg);
    BOOL TransparentImage (int hdcDest, int DstX, int DstY, int DstCx, int DstCy,int hSrc, int SrcX, int SrcY, int SrcCx, int SrcCy, int TransparentColor);BOOL UnhookWindowsHookEx(int hhk);
    BOOL UnregisterClassW (wchar* lpClassName, int hInstance);
    BOOL UnregisterClassA (char* lpClassName, int hInstance);
    BOOL UpdateWindow (int hWnd);
    BOOL ValidateRect (int hWnd, RECT* lpRect);
    short VkKeyScanW (short ch);
    short VkKeyScanA (short ch);
    int VtblCall (int ppVtbl, int fnNumber, int arg0);
    BOOL WaitMessage ();
    int WideCharToMultiByte (int CodePage, int dwFlags, wchar* lpWideCharStr, int cchWideChar, char* lpMultiByteStr, int cchMultiByte, char* lpDefaultChar, BOOL [] lpUsedDefaultChar);
    int WideCharToMultiByte (int CodePage, int dwFlags, wchar* lpWideCharStr, int cchWideChar, int lpMultiByteStr, int cchMultiByte, char* lpDefaultChar, BOOL [] lpUsedDefaultChar);
    int WindowFromDC (int lpPoint);
    int WindowFromPoint (POINT lpPoint);
}