/*******************************************************************************
 * Copyright (c) 2000, 2003 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
module dwt.events.modifyevent;

private import dwt.events.typedevent;

/**
 * Instances of this class are sent as a result of
 * text being modified.
 *
 * @see ModifyListener
 */

public final class ModifyEvent : TypedEvent {

	private import dwt.widgets.event;

/**
 * Constructs a new instance of this class based on the
 * information in the given untyped event.
 *
 * @param e the untyped event containing the information
 */
public this(Event e) {
	super(e);
}

}

